calc.invMME <- function(A,h2,lambda,var.QTL){
	print(paste("Solving mixed model equation",sep=""),quote=FALSE)
	n = nrow(A)
	v1=rep(1,n)

	top=cbind(t(v1)%*%v1,t(v1))
	invA=solve(A)
	bottom <- list()
	res <- list()
	resh2 <- list()
	for(i in 1:length(h2)) {
		for(j in 1:length(var.QTL)) {
			bottom[[j]] = cbind(v1,diag(n)+(lambda[i,j]*invA))
			res[[j]] = solve(rbind(top,bottom[[j]]))
		}
		resh2[[i]] = res
		bottom <- list()
		res <- list()
	}
	return(resh2)
}