controle.erreur <- function(h2,methods,var.QTL,GC){
	cpt=0

	# Test varQTL=0
	t=length(which(var.QTL==0))
	if(t>0) {
		cpt=1
		print(paste("Do not put QTL effect of 0 !",sep=""),quote=FALSE)
	}
	
	# Test h2=0 ou 1 avec GRAMMAR
	tmet=length(which(methods=="grammar"))
	th2=length(which(h2==0 | h2==1))
	if(tmet>0 & th2>0) {
		cpt=1
		print(paste("Do not enter h2=0 or 1 when using GRAMMAR",sep=""),quote=FALSE)
	}

	# Test GC avec FASTA ou QTDT
	treg=length(which(methods=="reg"))
	tgrammar=length(which(methods=="grammar"))
	if(GC==TRUE & (treg==0 & tgrammar==0)) {
		cpt=1
		print(paste("Genomic Control only available for reg and grammar",sep=""),quote=FALSE)
	}

	return(cpt)
}