grammar <- function(A,n,threshold,h2,lambda,var.QTL,mu,xprimx,XprimCuuX,XprimCuuCuuX,XprimCuuv1CuuX,SSEgrammar,GC,tmpvQTL){
	beta = sqrt(var.QTL)
	trA = sum(diag(A))
	v1 = rep(1,n)
	v1primv1 = t(v1)%*%v1
	v1primAv1 = t(v1)%*%A%*%v1

	e.denom = matrix(0,length(h2),length(beta))
	v.denom = matrix(0,length(h2),length(beta))
	e = matrix(0,length(h2),length(beta))
	v = matrix(0,length(h2),length(beta))
	robustness = matrix(0,length(h2),1)
	power = matrix(0,length(h2),length(beta))
	for(i in 1:length(h2)) {
		for(j in 1:length(beta)) {
			e.num.1 = beta[j] - beta[j]*(1/xprimx)*XprimCuuX[i,j]
			e.num.2 = sqrt((n-2)*xprimx)
			e.num = e.num.1 * e.num.2
			e.denom = sqrt(SSEgrammar[i,j])
			e[i,j] = e.num/e.denom
			v.num.1=(1-h2[i])*(1-(XprimCuuX[i,j]*(1/xprimx)))
			v.num.2=((1-h2[i])-(lambda[i,j]*h2[i]))*(1/xprimx)*(XprimCuuX[i,j]-XprimCuuCuuX[i,j]+(1/n)*XprimCuuv1CuuX[i,j])
			v.num = (n-2)*(v.num.1 - v.num.2)
			v.denom = SSEgrammar[i,j]
			v[i,j] = v.num/v.denom

			power[i,j]=1-pnorm(qnorm(1-(threshold/2),0,1),e[i,j],sqrt(v[i,j]))
		}
		robustness[i]=2*(1-pnorm(qnorm(1-(threshold/2),0,1),0,sqrt(v[i,1])))
	}
	a=cbind(h2,robustness)
	colnames(a) <- c("h2","robustness")
	b=matrix(0,length(h2),length(beta)-1)
	for(i in 1:length(h2)) {
		for(j in 1:(length(beta)-1)) {
			b[i,j]=power[i,1+j]
		}
	}

	rownames(b) <- as.character(h2)
	colnames(b) <- as.character(tmpvQTL[1:length(tmpvQTL)])

	if(GC==TRUE){
		c=cbind(h2,as.numeric(v[,1]))
		colnames(c) <- c("h2","GC")
		return(list(a,b,c))
	} else {
		return(list(a,b))
	}
}