recupA <- function(fileped,Afull){
  pedigree = read.table(fileped,header=FALSE) #ind pere mere bool_genotype
  n = length(pedigree[pedigree[,4]==1,1])
  print(paste("Loading relationship matrix A",sep=""),quote=FALSE)
  ind.genotyper = which(pedigree[,4]==1)
  A = Afull[ind.genotyper,ind.genotyper]
  pedgeno = pedigree[pedigree[,4]==1,]

  D=matrix(0,nrow(A),nrow(A))
  for(i in 1:nrow(pedgeno)) {
	desc=pedgeno[i,1]
	pdesc=pedgeno[i,2]
	mdesc=pedgeno[i,3]
	aii=A[i,i]
	si=which(pedigree[,1]==pdesc)
	if(length(si)>0) {
		asisi=Afull[si,si]
	} else {
		asisi=1
	}
	di=which(pedigree[,1]==mdesc)
	if(length(di)>0) {
		adidi=Afull[di,di]
	} else {
		adidi=1
	}
	if(length(di)>0 && length(si)>0) {
		asidi=Afull[si,di]
	} else {
		asidi=0
	}
	D[i,i]=aii - ((1/4)*asisi + (1/4)*adidi + (1/2)*asidi)
  }
  return(list(A,D))
} 