calc.XprimCuuv1CuuX <- function(A,h2,lambda,Cuu.h2){
	n = nrow(A)
	v1=rep(1,n)

	trA = sum(diag(A))

	res = matrix(0,length(h2),ncol(lambda))
	for(i in 1:length(h2)) {
		for(j in 1:ncol(lambda)) {
			elt1 = t(v1)%*%A%*%v1
			elt2 = lambda[i,j]*(t(v1)%*%Cuu.h2[[i]][[j]]%*%v1)
			elt3 = lambda[i,j]*(t(v1)%*%Cuu.h2[[i]][[j]]%*%Cuu.h2[[i]][[j]]%*%v1)
			elt4 = (1/n)*lambda[i,j]*(t(v1)%*%Cuu.h2[[i]][[j]]%*%v1%*%t(v1)%*%Cuu.h2[[i]][[j]]%*%v1)
			res[i,j] = elt1 - elt2 - elt3 + elt4
		}
	}
	return(res)
}