calc.ssefasta <- function(A,h2,lambda,var.QTL,XprimCuuX,XprimCuuCuuX,XprimCuuv1CuuX,xprimx,xprimAx,Cuu.h2){
	n = nrow(A)
	v1=rep(1,n)
	beta=sqrt(var.QTL)
	trA = sum(diag(A))

	res = matrix(0,length(h2),ncol(lambda))
	for(i in 1:length(h2)) {
		for(j in 1:ncol(lambda)) {
			# Partie en sigma_e
			elt1 = (n-2)*(1-h2[i])

			# Partie en sigma_e - lambda*sigma_u
			elt2.1 = sum(diag(Cuu.h2[[i]][[j]]))
			elt2.2 = (1/n)*t(v1)%*%Cuu.h2[[i]][[j]]%*%v1
			elt2.3.num = XprimCuuX[i,j] + (1/n)*XprimCuuv1CuuX[i,j] - XprimCuuCuuX[i,j]
			elt2.3.den = xprimx - XprimCuuX[i,j]
			elt2.3 = elt2.3.num/elt2.3.den
			elt2 = ((1-h2[i])-(lambda[i,j]*h2[i]))*(elt2.1-elt2.2-elt2.3)

			res[i,j] = elt1 - elt2
		}
	}
	return(res)
}