calc.ssegrammar <- function(A,h2,lambda,var.QTL,XprimCuuX,XprimCuuCuuX,XprimCuuv1CuuX,xprimx,xprimAx,Cuu.h2){
	n = nrow(A)
	v1=rep(1,n)
	beta=sqrt(var.QTL)
	trA = sum(diag(A))

	res = matrix(0,length(h2),ncol(lambda))
	for(i in 1:length(h2)) {
		for(j in 1:ncol(lambda)) {
			# Partie en sigma_e
			elt1.1 = n-2-sum(diag(Cuu.h2[[i]][[j]]))
			elt1.2 = (1/xprimx)*XprimCuuX[i,j]
			elt1.3 = solve(t(v1)%*%v1)%*%t(v1)%*%Cuu.h2[[i]][[j]]%*%v1
			elt1 = (1-h2[i])*(elt1.1+elt1.2+elt1.3)

			# Partie en beta carr
			elt2.1 = XprimCuuCuuX[i,j]
			elt2.2 = (1/xprimx)*(XprimCuuX[i,j]*XprimCuuX[i,j])
			elt2.3 = solve(t(v1)%*%v1)*(XprimCuuv1CuuX[i,j])
			elt2 = (beta[j]^2)*(elt2.1 - elt2.2 - elt2.3)

			# Partie en sigma_e - lambda*sigma_u
			elt3.1 = sum(diag(Cuu.h2[[i]][[j]]))
			elt3.2 = (1/n)*(t(v1)%*%Cuu.h2[[i]][[j]]%*%v1)
			elt3.3 = 2*((1/n)*(t(v1)%*%Cuu.h2[[i]][[j]]%*%Cuu.h2[[i]][[j]]%*%v1)-(1/(n^2))*(t(v1)%*%Cuu.h2[[i]][[j]]%*%v1%*%t(v1)%*%Cuu.h2[[i]][[j]]%*%v1))
			elt3.4 = sum(diag(Cuu.h2[[i]][[j]]%*%Cuu.h2[[i]][[j]]))-(1/(n^2))*(t(v1)%*%Cuu.h2[[i]][[j]]%*%v1%*%t(v1)%*%Cuu.h2[[i]][[j]]%*%v1)
			elt3.5 = (1/xprimx)*XprimCuuX[i,j]
			elt3.6 = (1/xprimx)*XprimCuuCuuX[i,j]
			elt3.7 = (1/n)*(1/xprimx)*(XprimCuuv1CuuX[i,j])
			elt3 = ((1-h2[i])-(lambda[i,j]*h2[i]))*(elt3.1 - elt3.2 + elt3.3 - elt3.4 - elt3.5 + elt3.6 - elt3.7)

			res[i,j] = elt1 + elt2 - elt3
		}
	}
	return(res)
}