calc.sseqtdt <- function(h2,var.QTL,A){
	beta = sqrt(var.QTL)
	n = nrow(A)
	trA = sum(diag(A))
	trAA = sum(diag(t(A)%*%A))
	v1 = rep(1,n)
	v1primAv1 = t(v1)%*%A%*%v1

	elt1 = (n-3)*(1-h2)
	elt2.1 = trA	
	elt2.2 = (1/n)*v1primAv1
	elt2.3.num = trAA - (2/n)*t(v1)%*%t(A)%*%A%*%v1 + (1/(n^2))*v1primAv1%*%v1primAv1 - (n/2) + (1/(2*n))*v1primAv1
	elt2.3.den = trA - (1/n)*v1primAv1 - ((n-1)/2)
	elt2.3 = elt2.3.num / elt2.3.den
	elt2.4 = 1
	elt2 = h2*(elt2.1-elt2.2-elt2.3-elt2.4)
	elt3 = beta^2*((n-1)/(2*n))

	res = matrix(0,length(h2),length(beta))
	for(i in 1:length(h2)) {
		res[i,]=elt1[i]+elt2[i]+elt3
	}
	return(res)
}