qtdt <- function(A,n,threshold,h2,var.QTL,mu,QprimQ,Qprimx,Qprim1,QprimAQ,SSEqtdt,SSEqtdt.rob,tmpvQTL){
	beta = sqrt(var.QTL)
	trA = sum(diag(A))
	v1 = rep(1,n)
	v1primv1 = t(v1)%*%v1
	v1primAv1 = t(v1)%*%A%*%v1

	# Calcul de la puissance (beta=0)
	e.num = sqrt(n-3)*(beta*((solve(QprimQ)%*%Qprimx)[3]) + mu*((solve(QprimQ)%*%Qprim1)[3]))
	v.num=(n-3)*(h2*(solve(QprimQ)%*%QprimAQ%*%solve(QprimQ))[3,3]+(1-h2)*(solve(QprimQ))[3,3])
	
	e.denom = matrix(0,length(h2),length(beta))
	v.denom = matrix(0,length(h2),length(beta))
	e = matrix(0,length(h2),length(beta))
	v = matrix(0,length(h2),length(beta))
	robustness = matrix(0,length(h2),length(beta))
	power = matrix(0,length(h2),length(beta))
	for(i in 1:length(h2)) {
		e.denom[i,] = sqrt(solve(QprimQ)[3,3])*sqrt(SSEqtdt[i,])
		v.denom[i,] = solve(QprimQ)[3,3]*SSEqtdt[i,]
		e[i,] = e.num/e.denom[i,]
		v[i,] = v.num[i]/v.denom[i,]
		power[i,]=1-pnorm(qnorm(1-(threshold/2),0,1),e[i,],sqrt(v[i,]))
	}

	# Calcul de la robustesse (beta=0)
	e.num.rob = sqrt(n-3)*mu*((solve(QprimQ)%*%Qprim1)[3])
	e.denom.rob = sqrt(solve(QprimQ)[3,3])*sqrt(SSEqtdt.rob)
	v.num.rob = v.num
	v.denom.rob = solve(QprimQ)[3,3]*SSEqtdt.rob
	e.rob = e.num.rob / e.denom.rob
	v.rob = v.num.rob / v.denom.rob
	robustness=2*(1-pnorm(qnorm(1-(threshold/2),0,1),e.rob,sqrt(v.rob)))

	a=cbind(h2,robustness)
	colnames(a) <- c("h2","robustness")
	b=matrix(0,length(h2),length(beta)-1)
	for(i in 1:length(h2)) {
		for(j in 1:(length(beta)-1)) {
			b[i,j]=power[i,1+j]
		}
	}
	rownames(b) <- as.character(h2)
	colnames(b) <- as.character(tmpvQTL[1:length(tmpvQTL)])
	return(list(a,b))
}